/******************************************************************************
*
* Tu bud definovan vetky dtove
* truktry ktor s v programe pouvaj
* naposledy modifikovan 10.4.2004
*
******************************************************************************/

#ifndef TYPES_H
#define TYPES_H

#include "ntddk.h"
#include "inc/mojetypy.h"
#include "inc/disklabel.h"
#include "inc/fs.h"
#include "inc/dinode.h"

#define   MAX_SEARCH_PAT   256
/* Kvli tomu aby oznaovanie bolo konzistentn, bsd unity sa zatia cel    */
/* prepisova nebud                                                         */

typedef struct _T_MAIN_DATA   T_MAIN_DATA;
typedef struct _T_VCB         T_VCB;
typedef struct _T_REQ_FCB     T_REQ_FCB;
typedef struct _T_FCB         T_FCB;
typedef struct _T_CCB         T_CCB;
typedef struct _T_VOLUME      T_VOLUME;
typedef struct _T_INODE       T_INODE;
typedef T_CCB              *PTR_T_CCB;
typedef T_FCB              *PTR_T_FCB;
typedef T_VCB              *PTR_T_VCB;
typedef T_VOLUME           *PTR_T_VOLUME;
typedef T_INODE            *PTR_T_INODE;
typedef T_MAIN_DATA        *PTR_T_MAIN_DATA;
typedef struct fs           T_SUPER_BLOCK;
typedef struct disklabel    T_DISK_LABEL;
typedef T_DISK_LABEL       *PTR_T_DISKLABEL;
typedef struct ufs2_dinode  T_DISK_INODE;
typedef struct dinode       T_OLD_DISK_INODE;
typedef T_DISK_INODE       *PTR_T_DISK_INODE;
typedef T_OLD_DISK_INODE   *PTR_T_OLD_DISK_INODE;


#define  MAIN_DATA_MAGIC    100
#define  VCB_MAGIC          200
#define  CCB_MAGIC          1982
#define  FCB_MAGIC          2004
#define  VOLUME_MAGIC       4674

struct _T_MAIN_DATA          /* Tu to vetko zana:) */
{
	int             Magic;
	UINT32          Flags;
	LIST_ENTRY      HeadVolume;
	/* Spojov zoznam primontovanch jednotiek  */
	ERESOURCE       MainResource;
	/* Synchonizcia prstupov k hlavnm dtam */
	PDRIVER_OBJECT  PtrMainDriverObject;
	/* Odloen odkaz na  ovlda         */
	PDEVICE_OBJECT	PtrMainDeviceObject;
	/* Odloen odkaz na riad. zariadenie */
};

struct _T_INODE
{
	PTR_T_VCB    PtrVCB;
	__uint32_t InodeNum;
};

struct _T_REQ_FCB
{
	FSRTL_COMMON_FCB_HEADER  CommonFCBHeader;
	SECTION_OBJECT_POINTERS  PtrSectionObject;
	ERESOURCE                MainResource;
	ERESOURCE                PagingIoResource;
};

struct _T_FCB
{
	int            Magic;
	UINT32         Flags;
	PTR_T_VCB      PtrParentVCB;           /* Jednotka ku ktorej ccb patr     */
	UINT32         ReferenceCount;
	UINT32         OpenHandleCount;
	UINT32         InodeNumber;             /* slo inode                     */
	// whenever a file stream has a create/open operation performed,
	//	the Reference count below is incremented AND the OpenHandle count
	//	below is also incremented.
	//	When an IRP_MJ_CLEANUP is received, the OpenHandle count below
	//	is decremented.
	//	When an IRP_MJ_CLOSE is received, the Reference count below is
	//	decremented.
	//	When the Reference count goes down to zero, the FCB can be de-allocated.
	//	Note that a zero Reference count implies a zero OpenHandle count.
	//	This invariant must always hold true ... (if it is really an invariant,
	// shoudn't the previous statement be redundant ... hmmm!!!)
	LIST_ENTRY    HeadCCB;    /* Spojov zoznam CCB-jednotlovch otvoren */
	LIST_ENTRY    NextFCB;
	T_DISK_INODE  DiskInode;  /* Obsah inodu z disku                      */
	T_REQ_FCB     ReqFCB;     /* truktry ktor potrebuje os z fcb       */
};

struct _T_CCB
{
	int            Magic;
	UINT32         Flags;
	LIST_ENTRY     NextCCB;
	PTR_T_FCB      PtrParentFCB;
	CHAR           PtrDirSearchPat[MAX_SEARCH_PAT];
	UINT64         ByteOfs;
	UINT8          MountPointOfs;
};

struct _T_VCB   /*Zznam ktor reprezentuje jednu primontovan jednotku*/
{
	int            Magic;
	UINT32         Flags;
	UINT32         FileOpenCount;
	BOOLEAN        Dismount ;
  /* Koko je otvorench sborov (adresrov) na celej jednotke               */
	PTR_T_VOLUME   PtrParentVolume;          /*odkaz na to co obaluje particie */
	NPAGED_LOOKASIDE_LIST FCBLookaside;/* Na ikovnejiu alokciu malych veci  */
	NPAGED_LOOKASIDE_LIST CCBLookaside;/* Na ikovnejiu alokciu malych veci  */
	LIST_ENTRY     HeadFCB;            /* Spoj .zoz. vetkch fcb na tejto vcb */
	// Cez containing sa dostanem tam kam sa chcem dostat
	int            PartNumber;         /* slo partcie ktor je primontovan */
	T_SUPER_BLOCK  SuperBlock;
	ERESOURCE      MainResource;       /* Na synchronizciu prstupu           */
	UINT64         SblockSec;
	UINT32         Direct;             /* Naj blok na ktor sta direct       */
	UINT32				 Indirect;		       /* Naj blok na ktor sta indirect     */
	UINT32         DoubleInd;          /* Naj blok na ktor sta double ind   */
	UINT32				 TripleInd;          /* Naj blok na ktor sta triple ind   */
	UINT64         PartOfset;
	/*Ofset part. v disklabeli je zo zaciatku disku, ja vsak pracujem na part. */
};

struct _T_VOLUME
{
	int             Magic;
	UINT32          Flags;
	PDEVICE_OBJECT  PtrVolumeDevice;     /* Zariadenie ktor sa vytvorilo      */
	PDEVICE_OBJECT  PtrTargetDevice;    /* Partcia na ktor sa pe           */
	PVPB            PtrVPB;             /* truktra io manara o partcii    */
	NPAGED_LOOKASIDE_LIST FCBLookaside; /* Na ikovnejiu alokciu malych veci */
	NPAGED_LOOKASIDE_LIST CCBLookaside; /* Na ikovnejiu alokciu malych veci */
	ERESOURCE       MainResource;       /* Synchronizacia                      */
	T_VCB           Partitions[MAXPARTITIONS];  /*Tu budu ulozene nase vcb  */
	BOOLEAN         Present[MAXPARTITIONS];
	BOOLEAN         Dismount ;
	T_FCB     	    VolumeFCB;         /* FCB na otvorenia  samotnej jednotky  */
	//sranda je v tom ze akoze prinalezi k prvej vcb
	UINT32          FileOpenCount;
	T_DISK_LABEL    DiskLabel;         /* Bsd daje o disku                    */
	UINT64          StartSector;
	//Rozdiel medzi relatvnym a absoltnym adresovanm na disku
	LIST_ENTRY      NextVolume;        /* To je to alokovane plink a blink     */
	int             FirstPart;
	//docasne aby sa najprv pozeralo na prvu(zvycajne root_
};

#endif  /*TYPES_H*/
