#include "inc/ffs.h"
#include "create.tmh"
/*****************************************************************************
* Createmain
* Obsluhuje poiadavky na otvorenie zariadenia ktor nie je priraden k
* iadnej jednotke. Je to vtedy ke chcem riadi priamo cel ovlda
******************************************************************************/

NTSTATUS
CreateMain(
	IN PDEVICE_OBJECT  PtrDeviceObject,
	IN PIRP  PtrIrp)
{
	//PtrIrp->IoStatus.Status = STATUS_SUCCESS;
	//PtrIrp->IoStatus.Information = FILE_OPENED;
	//IoCompleteRequest(PtrIrp, IO_NO_INCREMENT);
	//kompletuje horne create inak je tu duplicita
	return(STATUS_SUCCESS);
} /*CreateMain*/


/******************************************************************************
* Vytvor
* Rozhodol som sa zatia vykala na asynchrnne poiadavky
*IRQL = PASSIVE_LEVEL.  -lebo je to rtlunicodestringtoansistring !!!
******************************************************************************/
NTSTATUS
		Create(
			IN PDEVICE_OBJECT  PtrDeviceObject,
			IN PIRP  PtrIrp)
{
	NTSTATUS           Result = STATUS_INVALID_PARAMETER;
  //tu bude vystupny kod procedury
  PIO_STACK_LOCATION PtrIrpSp = NULL;
	//tu su ulozene  vstupne parametre z irpcka
	PFILE_OBJECT			 PtrNewFO = NULL;
	//dostali sme smernik na tento objekt ktory sa vlastne ma otvorit
	//treba tam daco doplnit
	PFILE_OBJECT			 PtrRelatedFO = NULL;
	//ak toto je nenulove tak sa zacne parsovat odtialto
	PTR_T_CCB          PtrRelatedCCB = NULL, PtrNewCCB = NULL;
	PTR_T_FCB				   PtrRelatedFCB = NULL, PtrNewFCB = NULL;
	//releated uz je hotove keby sme ho nahodou potrebovali
	//new musim vytvorit ja
	int                Step = 0;
	UNICODE_STRING     TargetObjName;
	UNICODE_STRING     RelatedObjName;
	ANSI_STRING        String ;
	PTR_T_VCB          PtrVCB;
	PTR_T_VOLUME       PtrVolume = NULL;
	PTR_T_FCB          PtrStartFCB;
	//rozne podmienky na otovreny objekt
	BOOLEAN					   DirectoryOnlyRequested = FALSE;
	BOOLEAN					   FileOnlyRequested = FALSE;
	BOOLEAN					   NoBufferingSpecified = FALSE;
	BOOLEAN					   WriteThroughRequested = FALSE;
	BOOLEAN					   DeleteOnCloseSpecified = FALSE;
	BOOLEAN					   NoExtAttrKnowledge = FALSE;
	BOOLEAN					   CreateTreeConnection = FALSE;
	BOOLEAN					   OpenByFileId = FALSE;
	BOOLEAN					   PageFileManipulation = FALSE;
	BOOLEAN					   OpenTargetDirectory = FALSE;
	BOOLEAN					   IgnoreCaseWhenChecking = FALSE;
	BOOLEAN            RootOpen  = FALSE;
	//poziadavky co sa bude robit ak ?
	unsigned long			 RequestedOptions = 0;
	//poziadavky na to co to ma byt
	unsigned long			 RequestedDisposition = 0;
	//poziadavky co sa bude robit ak ?
	UINT8						   FileAttributes = 0;
  //atributy suboru
  ANSI_STRING        SearchString;
  T_FCB              MyFCB;
  T_INODE            Inode;

	__try
	{
	  Inode.InodeNum = 0;
	  Inode.PtrVCB   = NULL;
	  //Otvorenie samotnho ovldaa
	  if (PtrDeviceObject == GlobalData.PtrMainDeviceObject)
	  {
			Result = (CreateMain(PtrDeviceObject,PtrIrp));
			DoTraceMessage(FFS_CREATE_CLOSE,"Main device open");
			__leave;
		}
		if (PtrIrp->Overlay.AllocationSize.HighPart)
		{
			DoTraceMessage(FFS_CREATE_CLOSE,"Big files not yet supported");
			__leave;
		}
		//Neviem robi s vekmi sbormi (Zatia)
		//Teraz mus by device u iba nejak primontovan jednotka
		PtrIrpSp      = IoGetCurrentIrpStackLocation(PtrIrp);
		PtrNewFO      = PtrIrpSp->FileObject;
		TargetObjName = PtrNewFO->FileName;
		PtrRelatedFO  = PtrNewFO->RelatedFileObject;
		RtlUnicodeStringToAnsiString(&String,&(PtrNewFO->FileName),TRUE);
		DoTraceMessage(FFS_CREATE_CLOSE,"Want open %s",String.Buffer);
		RtlFreeAnsiString(&String);
		/*************************************************************************/
		//Two values are supplied in the Create.Options field:
		//(a) the actual user supplied options
		//(b) the create disposition
		RequestedOptions =
		  (PtrIrpSp->Parameters.Create.Options & FILE_VALID_OPTION_FLAGS);
    DoTraceMessage(FFS_CREATE_CLOSE,"Options %u",RequestedOptions);
    //The file disposition is packed with the user options ...
		//Disposition includes FILE_SUPERSEDE, FILE_OPEN_IF, etc.
		RequestedDisposition =
		  ((PtrIrpSp->Parameters.Create.Options >> 24) && 0xFF);

		FileAttributes	= (UINT8)
		(PtrIrpSp-> Parameters.Create.FileAttributes & FILE_ATTRIBUTE_VALID_FLAGS);

		// Get the options supplied by the user
		// User specifies that returned object MUST be a directory.
		//Lack of presence of this flag does not mean it *cannot* be a
		//directory *unless* FileOnlyRequested is set (see below)

		//Presence of the flag however, does require that the returned object be
		//a directory (container) object.
		DirectoryOnlyRequested = ((RequestedOptions & FILE_DIRECTORY_FILE) ? TRUE : FALSE);

		// User specifies that returned object MUST NOT be a directory.
		//Lack of presence of this flag does not mean it *cannot* be a
		//file *unless* DirectoryOnlyRequested is set (see above).

		//Presence of the flag however does require that the returned object be
		//a simple file (non-container) object.
		FileOnlyRequested = ((RequestedOptions & FILE_NON_DIRECTORY_FILE) ? TRUE : FALSE);

		// We cannot cache the file if the following flag is set.
		//However, things do get a little bit interesting if caching
		//has been already initiated due to a previous open ...
		//(maintaining consistency then becomes a little bit more
		//of a headache - see read/write file descriptions)
		NoBufferingSpecified = ((RequestedOptions & FILE_NO_INTERMEDIATE_BUFFERING) ? TRUE : FALSE);

		// Write-through simply means that the FSD must *not* return from
		//	a user write request until the data has been flushed to secondary
		//	storage (either to disks directly connected to the node or across
		//	the network in the case of a redirector)
		WriteThroughRequested = ((RequestedOptions & FILE_WRITE_THROUGH) ? TRUE : FALSE);

		// Not all of the native file system implementations support
		//	the delete-on-close option. All this means is that after the
		//	last close on the FCB has been performed, your FSD should
		//	delete the file. It simply saves the caller from issuing a
		//	separate delete request. Also, some FSD implementations might choose
		//	to implement a Windows NT idiosyncratic behavior wherein you
		//	could create such "delete-on-close" marked files under directories
		//	marked for deletion. Ordinarily, a FSD will not allow you to create
		//	a new file under a directory that has been marked for deletion.
		DeleteOnCloseSpecified = ((RequestedOptions & FILE_DELETE_ON_CLOSE) ? TRUE : FALSE);

		NoExtAttrKnowledge = ((RequestedOptions & FILE_NO_EA_KNOWLEDGE) ? TRUE : FALSE);

		// The following flag is only used by the LAN Manager redirector
		//	to	initiate a "new mapping" to a remote share. Typically,
		//	a FSD will not see this flag (especially disk based FSD's)
		CreateTreeConnection = ((RequestedOptions & FILE_CREATE_TREE_CONNECTION) ? TRUE : FALSE);

		// The NTFS file system for exmaple supports the OpenByFileId option.
		//	Your FSD may also be able to associate a unique numerical ID with
		//	an on-disk object. The caller would get this ID in a "query file
		//	information" call.

		//	Later, the caller might decide to reopen the object, this time
		//	though it may supply your FSD with the file identifier instead of
		//	a file/path name.
		OpenByFileId = ((RequestedOptions & FILE_OPEN_BY_FILE_ID) ? TRUE : FALSE);

		// Are we dealing with a page file?
		PageFileManipulation =
		  ((PtrIrpSp->Flags & SL_OPEN_PAGING_FILE) ? TRUE : FALSE);

		// The open target directory flag is used as part of the sequence of
		//	operations performed by the I/O Manager is response to a file/dir
		//	rename operation. See the explanation in the book for details.
		OpenTargetDirectory =
		  ((PtrIrpSp->Flags & SL_OPEN_TARGET_DIRECTORY) ? TRUE : FALSE);

		// If your FSD supports case-sensitive file name checks, you may
		//	choose to honor the following flag ...
    IgnoreCaseWhenChecking =
      ((PtrIrpSp->Flags & SL_CASE_SENSITIVE) ? TRUE : FALSE);
		/************************************************************************/
		PtrVolume = PtrDeviceObject->DeviceExtension;
		if (PtrVolume->Magic!= VOLUME_MAGIC) __leave;
		ExAcquireResourceExclusiveLite(&(PtrVolume->MainResource), TRUE);
    Step++;/*1*/

		if (PtrRelatedFO)
		{
			DoTraceMessage(FFS_CREATE_CLOSE,"Related fo present");
			Result = CheckBoth(PtrRelatedFO->FsContext2);
			if (!NT_SUCCESS(Result)) __leave;
			DoTraceMessage(FFS_CREATE_CLOSE,"Related fo ok");
			PtrRelatedCCB = (PTR_T_CCB)(PtrRelatedFO->FsContext2);
			PtrRelatedFCB = PtrRelatedCCB->PtrParentFCB;
			RelatedObjName = PtrRelatedFO->FileName;
			PtrVCB = PtrRelatedFCB->PtrParentVCB;
			Inode.PtrVCB   = PtrVCB;
		}
		else PtrVCB =  &(PtrVolume->Partitions[PtrVolume->FirstPart]);
		Result = STATUS_INVALID_PARAMETER;
		//aby som trochu usertril v niektrych ifoch trochu miesta
		/******************************************************************/
		//if ((PtrNewFO->FileName.Length == 0) && (PtrRelatedFO == NULL))
		if ((PtrNewFO->FileName.Length == 0) && (PtrRelatedFO == NULL)
		||
		(PtrRelatedFCB == &(PtrVolume->VolumeFCB)))
		{
			DoTraceMessage(FFS_CREATE_CLOSE,"Volume open");
			if (DirectoryOnlyRequested)
			{
				// a volume is not a directory
				Result = STATUS_NOT_A_DIRECTORY;
				__leave;
			}
			if ((RequestedDisposition != FILE_OPEN) &&
			(RequestedDisposition != FILE_OPEN_IF))
			{
				// cannot create a new volume, I'm afraid ...
				Result = STATUS_ACCESS_DENIED;
				__leave;
			}
			Result = STATUS_SUCCESS;
	    Result = CreateCCB(&PtrNewCCB,&(PtrVolume->VolumeFCB));
		  if (!NT_SUCCESS(Result)) __leave;
	    PtrNewFO->FsContext2=PtrNewCCB;
	    DoTraceMessage(FFS_CREATE_CLOSE,"Volume open ok");
	    //Hranie sa s detailami by som mohol zatial aj vypustit
	    __leave;
		}
		/********************************************************************/
		//na tomto mieste sme si teda isty ze sa nejedna ani o otvorenie jednotky
		//ani o otvorenie ovladaca
		if (PtrVolume->Dismount)
		{
			DoTraceMessage(FFS_CREATE_CLOSE,"Dismount pending - create aborted");
			__leave;
		}
		if (OpenByFileId) __leave;
		//toto treba dokladne testovat
		//otovrenie hlavneho adresara
		if ((TargetObjName.Length == 2) && (!(PtrRelatedFO)))
		{
		  // this is an open of the root directory, ensure that	the caller has not requested a file only
			DoTraceMessage(FFS_CREATE_CLOSE,"Root directory open");
			if (FileOnlyRequested || (RequestedDisposition == FILE_SUPERSEDE) ||
			(RequestedDisposition == FILE_OVERWRITE) ||
			(RequestedDisposition == FILE_OVERWRITE_IF))
			{
				Result = STATUS_FILE_IS_A_DIRECTORY;
				__leave;
			}
			RootOpen = TRUE;
			Result= STATUS_SUCCESS;

		}
		if (PtrRelatedFO)
		{
			 if (!(FLAG_ON(PtrRelatedFCB->DiskInode.di_mode,IFDIR))) __leave;
			//musi byt adresar
			if ((RelatedObjName.Length == 0) ||
			  (RelatedObjName.Buffer[0] != W_TOKEN)) __leave;
			//musi zacinat na lomitko, byt nenulovy
			//daco
			PtrStartFCB =PtrRelatedFCB;
			Inode.InodeNum = PtrStartFCB->InodeNumber;
			//a teda zacne sa parsovat odtialto
		}
		else
		{
			TargetObjName.Buffer++;
			//koren virtualneho stromu
			Inode.InodeNum = ROOT_INODE;
			Inode.PtrVCB   =PtrVCB;
			Result =ReadFCB(&MyFCB,&Inode);
			if (!NT_SUCCESS(Result)) __leave;
			PtrStartFCB = &MyFCB;

		}

		Result = RtlUnicodeStringToAnsiString(&SearchString,&TargetObjName,TRUE);
		if (!NT_SUCCESS(Result)) __leave;
		Step++;/*2*/
		if (!(RootOpen))
		{
			DoTraceMessage(FFS_CREATE_CLOSE,"Parsing %s",SearchString.Buffer);
			Result = PathLookup(SearchString.Buffer,PtrStartFCB,&Inode);
		}
		            else {
									     Inode.InodeNum = ROOT_INODE;
									     Inode.PtrVCB   = PtrVCB;
									     //koren virt stromu
										 }
		if (!NT_SUCCESS(Result)) __leave;
		DoTraceMessage(FFS_CREATE_CLOSE,"Inode num is %u",Inode.InodeNum);


		PtrNewFCB =   SearchInode(&Inode);
		if (PtrNewFCB==NULL) Result =CreateFCB(&(PtrNewFCB),&Inode);
	  if (!NT_SUCCESS(Result)) __leave;
	  if ( (FileOnlyRequested)
	  && (!(FLAG_ON(PtrNewFCB->DiskInode.di_mode,IFREG))) ) __leave;
    if ( (DirectoryOnlyRequested)
	  && (!(FLAG_ON(PtrNewFCB->DiskInode.di_mode,IFDIR))) ) __leave;
    Step++;/*3*/
	  Result = CreateCCB(&PtrNewCCB,PtrNewFCB);
		if (!NT_SUCCESS(Result)) __leave;

		PtrNewFO->Vpb = PtrVCB->PtrParentVolume->PtrVPB;
		PtrNewFO->PrivateCacheMap = NULL;
		PtrNewFO->FsContext =
			(void *)( &(PtrNewFCB->ReqFCB.CommonFCBHeader) );
		PtrNewFO->SectionObjectPointer =
			&(PtrNewFCB->ReqFCB.PtrSectionObject) ;
		PtrNewFO->FsContext2 = PtrNewCCB;
			//UAAAAAAAAA












		Result = STATUS_SUCCESS;
	}
	__finally
	{
		if (Step>0)  ExReleaseResourceLite(&(PtrVolume->MainResource));
		if (Step>1)  RtlFreeAnsiString(&SearchString);
	}
	PtrIrp->IoStatus.Status=Result;
	PtrIrp->IoStatus.Information = FILE_OPENED;
	IoCompleteRequest(PtrIrp, IO_NO_INCREMENT);
	DoTraceMessage(FFS_CREATE_CLOSE,"Create result %u",Result);
	return (Result);
} /* Vytvor*/

