//tam (a v dach) je to  vetko definovan

#include "inc/ffs.h"
#include "init.tmh"


/*********************************************************************************
*
* Vol sa pri zaveden ovldaa do os.
* Inicializcia ovldaa.
*
**********************************************************************************/
NTSTATUS DriverEntry(
	IN PDRIVER_OBJECT PtrFfsDriver,
	IN PUNICODE_STRING PtrRegistrovaCesta
					 )
{
	UNICODE_STRING DeviceName,DosDeviceName;
	NTSTATUS       Result = STATUS_SUCCESS;
	int            Step = 0;

	__try
	{
		__try
		{
            DbgPrint("%s version %s is starting",DRIVER_NAME,STR_VERSION);
            Step++;
			RtlZeroMemory(&GlobalData,sizeof(GlobalData));
			GlobalData.PtrMainDriverObject=PtrFfsDriver;
			//schovm si ho do zsoby
			GlobalData.Magic=MAIN_DATA_MAGIC;

			Result=ExInitializeResourceLite(&(GlobalData.MainResource));
			if (!NT_SUCCESS(Result)) __leave;
			Step++;
			//inicializcia sych. zdroja - treba exdelete pred dealokovanm

			InitializeListHead(&(GlobalData.HeadVolume));

			InicializujSmernikyNaFunkcie(PtrFfsDriver);
			//nastavenie smernkov na funkcie ktor viem robi
			RtlInitUnicodeString(&DeviceName,DEVICE_NAME);

			Result=IoCreateDevice(
			PtrFfsDriver,
			0,                              //vekos dt v extension
			&DeviceName,
			FILE_DEVICE_DISK_FILE_SYSTEM,
			0,                 //peciality
			FALSE,
			&GlobalData.PtrMainDeviceObject);
			//Vytvorilo sa mocnm volanm zariadenie
			if (!NT_SUCCESS(Result)) __leave;
			Step++;

			RtlInitUnicodeString(&DosDeviceName, DOS_DEVICE_NAME);
			Result=IoCreateSymbolicLink(&DosDeviceName, &DeviceName);
			if (!NT_SUCCESS(Result)) __leave;
			//na to aby fungoval unload
			Step++;

			IoRegisterFileSystem(GlobalData.PtrMainDeviceObject);
			//Zaregistrovali sme sa ako sborov systm;
			Step++;
			//tart event tracingu
#if defined(TARGETING_Win2K)

			WPP_SYSTEMCONTROL(PtrFfsDriver);
			WPP_INIT_TRACING(GlobalData.PtrMainDeviceObject,
			                 PtrRegistrovaCesta);
#else
      WPP_INIT_TRACING(PtrFfsDriver,PtrRegistrovaCesta);
#endif
      DoTraceMessage(FFS_INIT_DONE,  "Hello, %s driver, version %s, compile date %s",
                     DRIVER_NAME,STR_VERSION,DATE );
      DoTraceMessage(FFS_INIT_DONE,"Init succeed");

      }

		__finally
		{
			if (!NT_SUCCESS(Result) || AbnormalTermination())
			{
				// Switch pokrauje - ke bude krok 3 vykon sa aj 2.
				switch (Step)
				{
				case 5:
					IoUnregisterFileSystem(GlobalData.PtrMainDeviceObject);
				case 4:
					IoDeleteSymbolicLink(&DosDeviceName);
				case 3:
					IoDeleteDevice(GlobalData.PtrMainDeviceObject);
				case 2:
					ExDeleteResourceLite(&(GlobalData.MainResource));
				}
			}
		}
	}
	__except (FilterVynimky(GetExceptionCode()))
	{
		Result = ObsluhaVynimky(NULL,GetExceptionCode());
	}
	return(Result);
} /* DriverEntry */
/*********************************************************************************
*
* Tu sa zaregistruje o vlastne n ovlda doke
*
*********************************************************************************/
VOID InicializujSmernikyNaFunkcie (IN PDRIVER_OBJECT PtrFfsDriver)
{
   PtrFfsDriver->MajorFunction[IRP_MJ_DEVICE_CONTROL]  = Rozhod;
   PtrFfsDriver->MajorFunction[IRP_MJ_CREATE] = Rozhod;
   PtrFfsDriver->MajorFunction[IRP_MJ_FILE_SYSTEM_CONTROL] = Rozhod;
   PtrFfsDriver->MajorFunction[IRP_MJ_QUERY_VOLUME_INFORMATION] = Rozhod;
   PtrFfsDriver->MajorFunction[IRP_MJ_QUERY_INFORMATION] = Rozhod;
   PtrFfsDriver->MajorFunction[IRP_MJ_DIRECTORY_CONTROL] = Rozhod;
   PtrFfsDriver->MajorFunction[IRP_MJ_CLOSE] = Rozhod;
   PtrFfsDriver->MajorFunction[IRP_MJ_CLEANUP] = Rozhod;
   PtrFfsDriver->MajorFunction[IRP_MJ_READ] = Rozhod;

} /* InicializujSmernikyNaFunkcie */
