#include "inc/ffs.h"
#include "qdir.tmh"
/*****************************************************************************
* Rozdeluje podla poiadavky o sa vlastne bude robi
*****************************************************************************/
NTSTATUS
QueryDirectory (
	PDEVICE_OBJECT		PtrDeviceObject,
	PIRP					PtrIrp)
{
	NTSTATUS                        Result = STATUS_INVALID_PARAMETER;
	PIO_STACK_LOCATION              PtrIrpSp = NULL;
	PTR_T_FCB                       PtrFCB = NULL;
	PTR_T_CCB                       PtrCCB = NULL;
	PFILE_OBJECT                    PtrFO = NULL;
  int                             Step = 0;
  unsigned long			              BufferLength = 0;
	PUNICODE_STRING					        PtrSearchPattern = NULL;
	FILE_INFORMATION_CLASS          FileInformationClass;
	unsigned long			              FileIndex = 0;
	BOOLEAN					                RestartScan = FALSE;
	BOOLEAN					                ReturnSingleEntry = FALSE;
	BOOLEAN					                IndexSpecified = FALSE;
	PEXTENDED_IO_STACK_LOCATION     PtrExIrpSp = NULL;
	//V ddk nie su urcite parametre
	//toto ale implikuje zavislost od gnu ntifs.h
	BOOLEAN					                FirstTimeQuery = FALSE;
  ANSI_STRING                  ToSearch;
  //tu sa nejako nikto nezhoduje s nikym
  ANSI_STRING                     Test;
  UINT32                           MyLength = 0;
  PTR_T_VOLUME                    PtrVolume = NULL;

	__try
	{
		PtrIrpSp = IoGetCurrentIrpStackLocation(PtrIrp);
		PtrExIrpSp = (PEXTENDED_IO_STACK_LOCATION) PtrIrpSp;
		if ((PtrIrpSp->MinorFunction) != IRP_MN_QUERY_DIRECTORY) __leave;
		PtrVolume = PtrDeviceObject->DeviceExtension;
//doplnit kontrolu
		ExAcquireResourceSharedLite(&(PtrVolume->MainResource),TRUE);
		Step++;/*1*/
		if (PtrVolume->Dismount) __leave;

		PtrFO = PtrIrpSp->FileObject;
		if (PtrFO == NULL) __leave;
		Result = CheckBoth(PtrFO->FsContext2);
		if (!NT_SUCCESS(Result)) __leave;
		PtrCCB = (PtrFO->FsContext2);
		PtrFCB = PtrCCB->PtrParentFCB;
		//Result = STATUS_NO_SUCH_FILE;
    Result = STATUS_NO_MORE_FILES;
		BufferLength = PtrExIrpSp->Parameters.QueryDirectory.Length;
		PtrSearchPattern = PtrExIrpSp->Parameters.QueryDirectory.FileName;
		//uz ma z tych nezrovnalosti medzi ifs a gnuifs boli hlava
		FileInformationClass = PtrExIrpSp->Parameters.QueryDirectory.FileInformationClass;
		FileIndex = PtrExIrpSp->Parameters.QueryDirectory.FileIndex;
		RestartScan       = (PtrIrpSp->Flags & SL_RESTART_SCAN);
		ReturnSingleEntry = (PtrIrpSp->Flags & SL_RETURN_SINGLE_ENTRY);
		IndexSpecified    = (PtrIrpSp->Flags & SL_INDEX_SPECIFIED);

		if (PtrSearchPattern != NULL)
		{
		// User has supplied a search pattern
		// Now validate that the search pattern is legitimate; this is
		// dependent upon the character set acceptable to your FSD.
		// Once you have validated the search pattern, you must
		// check whether you need to store this search pattern in
		// the CCB.
			//RtlInitAnsiString(&ToSearch,PtrSearchPattern->Buffer);
			RtlUnicodeStringToAnsiString(&ToSearch,PtrSearchPattern,TRUE);
			Step++;/*2*/
			if (PtrCCB->PtrDirSearchPat[0] == END)
			{
				// This must be the very first query request.
		    FirstTimeQuery = TRUE;

		    if (ToSearch.Length >MAX_SEARCH_PAT)
		    {
					DbgPrint(DRIVER_NAME"Pretiekol vyhladavaci buffer vo ccb");
					Result = STATUS_BUFFER_OVERFLOW;
					__leave;
				}
				RtlCopyMemory(PtrCCB->PtrDirSearchPat,ToSearch.Buffer,ToSearch.Length+1);
			}
			else
			{
				// We should ignore the search pattern in the CCB and instead,
				// use the user-supplied pattern for this particular query
				// directory request.
			}
		}/*Then Ptrsearchpattern=!null*/
		else
		{
			if (PtrCCB->PtrDirSearchPat[0] == END)
		  {
				// This MUST be the first directory query operation (else the
			  // DirectorySearchPattern field would never be NULL. Also, the caller
				// has neglected to provide a pattern so we MUST invent one.
				// Use "*" (following NT conventions) as your search pattern
				// and store it in the PtrCCB->DirectorySearchPattern field.
				//neposlal nic a predchadzajuca je prazdna - vyrobime so hviezdicku
				PtrCCB->PtrDirSearchPat[0]='*';
				PtrCCB->PtrDirSearchPat[1]=END;
				FirstTimeQuery = TRUE;
				RtlInitAnsiString(&ToSearch,PtrCCB->PtrDirSearchPat);
			}
			else
			{
				// The caller has not supplied any search pattern that we are
				// forced to use. However, the caller had previously supplied
				// a pattern (or we must have invented one) and we will use it.
				// This is definitely not the first query operation on this
				// directory using this particular file object.
				// Neposlal nic ale mame nejaku z minula

				RtlInitAnsiString(&ToSearch,PtrCCB->PtrDirSearchPat);
			}
		}/*if (PtrSearchPattern != NULL)*/
		Result =DirInfo(&ToSearch,PtrCCB,PtrIrp->AssociatedIrp.SystemBuffer,
		                BufferLength,&MyLength,
		                FileInformationClass,ReturnSingleEntry);

	}
	__finally
	{
		switch (Step)
		{
			case 2:
			 RtlFreeAnsiString(&ToSearch);
			case 1:
			 ExReleaseResourceLite(&(PtrVolume->MainResource));
		} /*switch*/
	}/*finally */
	if ((FirstTimeQuery) && (MyLength == 0)&& (Result ==STATUS_SUCCESS))
	  Result = STATUS_NO_SUCH_FILE;
	if ( (!(FirstTimeQuery)) &&(MyLength == 0) && (Result == STATUS_SUCCESS) )
	  Result = STATUS_NO_MORE_FILES;
	PtrIrp->IoStatus.Information =MyLength;
	PtrIrp->IoStatus.Status = Result;
	IoCompleteRequest(PtrIrp, IO_NO_INCREMENT);
	return (Result);
}/*QueryVolume*/