#include "inc/ffs.h"
#include "qvolinf.tmh"
/*****************************************************************************
* Rozdeluje podla poiadavky o sa vlastne bude robi
*****************************************************************************/
NTSTATUS
QueryVolume (
	PDEVICE_OBJECT		PtrDeviceObject,
	PIRP					PtrIrp)
{
	NTSTATUS                        Result = STATUS_DRIVER_INTERNAL_ERROR;
	PIO_STACK_LOCATION              PtrIrpSp;
	T_VCB                          *PtrVCB;
  int                             Step = 0;
  int                             CallerLength = 0;
  int                             MyLength = 0;
  int                             StrLen = 0;
  int                             i = 0;
  int32_t                         Pom = 0;
  PTR_T_VOLUME                    PtrVolume;
  FS_INFORMATION_CLASS            FsInformationClass;
  PFILE_FS_VOLUME_INFORMATION		  PtrVolInfo	  = NULL;
	PFILE_FS_SIZE_INFORMATION		    PtrSizeInfo	  = NULL;
	PFILE_FS_ATTRIBUTE_INFORMATION	PtrAttrInfo	  = NULL;
	PFILE_FS_DEVICE_INFORMATION		  PtrDeviceInfo	= NULL;
	PFILE_FS_FULL_SIZE_INFORMATION	PtrFullInfo	  = NULL;
	__try
	{
		PtrIrpSp = IoGetCurrentIrpStackLocation(PtrIrp);
		PtrVolume = PtrDeviceObject->DeviceExtension;
//doplnit kontrolu
		ExAcquireResourceSharedLite(&(PtrVolume->MainResource),TRUE);
		Step++;/*1*/
    PtrVCB= &(PtrVolume->Partitions[PtrVolume->FirstPart]);
		CallerLength = PtrIrpSp->Parameters.QueryVolume.Length;
		FsInformationClass = PtrIrpSp->Parameters.QueryVolume.FsInformationClass;
		Result = STATUS_BUFFER_OVERFLOW;
		switch(FsInformationClass)
		{
			case FileFsVolumeInformation:
			  PtrVolInfo = PtrIrp->AssociatedIrp.SystemBuffer;
			  StrLen = strlen((char *)&(PtrVCB->SuperBlock.fs_fsmnt))*sizeof(WCHAR);
			  MyLength  = sizeof(FILE_FS_VOLUME_INFORMATION) + StrLen;
        if (CallerLength<MyLength) __leave;
			  RtlZeroMemory(PtrVolInfo,CallerLength);
			  PtrVolInfo->VolumeLabelLength = StrLen;
				PtrVolInfo->SupportsObjects = FALSE;
				PtrVolInfo->VolumeSerialNumber = PtrVCB->SuperBlock.fs_id[0];
				//dokoncit
				for (i=0;i<=StrLen;i++)
				  PtrVolInfo->VolumeLabel[i] = PtrVCB->SuperBlock.fs_fsmnt[i];
				//ehm ehm
				Result = STATUS_SUCCESS;
			break;

			case FileFsAttributeInformation:
				PtrAttrInfo = PtrIrp->AssociatedIrp.SystemBuffer;
				MyLength = sizeof(FILE_FS_ATTRIBUTE_INFORMATION)+sizeof(FS_NAME);
				if (CallerLength<MyLength)  __leave;
				RtlZeroMemory(PtrAttrInfo,CallerLength);
				PtrAttrInfo->MaximumComponentNameLength =  MAX_NAME_LENGTH;
				PtrAttrInfo->FileSystemNameLength =sizeof(FS_NAME) ;
				RtlCopyMemory(&(PtrAttrInfo->FileSystemName),FS_NAME,sizeof(FS_NAME));
		    Result = STATUS_SUCCESS;
		   break;

		   case FileFsDeviceInformation:
		     PtrDeviceInfo = PtrIrp->AssociatedIrp.SystemBuffer;
		     MyLength = sizeof(FILE_FS_DEVICE_INFORMATION);
		     if (CallerLength<MyLength) __leave;
		     RtlZeroMemory(PtrDeviceInfo,CallerLength);
		     PtrDeviceInfo->DeviceType = FILE_DEVICE_DISK;
		     PtrDeviceInfo->Characteristics = FILE_DEVICE_IS_MOUNTED;
		     Result = STATUS_SUCCESS;
		   break;

		   case FileFsSizeInformation:
		     PtrSizeInfo = PtrIrp->AssociatedIrp.SystemBuffer;
		     MyLength = sizeof (FILE_FS_SIZE_INFORMATION);
		     if (CallerLength<MyLength)  __leave;
		     RtlZeroMemory(PtrSizeInfo,CallerLength);
		     Pom = PtrVCB->SuperBlock.fs_old_size;
		     PtrSizeInfo->TotalAllocationUnits.LowPart = Pom;
		     Pom = PtrVCB->SuperBlock.fs_old_cstotal.cs_nbfree;
		     PtrSizeInfo->AvailableAllocationUnits.LowPart = Pom;
		     //horna je uz znulovana
         PtrSizeInfo->SectorsPerAllocationUnit =

         PtrSizeInfo->BytesPerSector = SECTOR_SIZE;
         Result = STATUS_SUCCESS;
       break;

       case FileFsFullSizeInformation:
         PtrFullInfo = PtrIrp->AssociatedIrp.SystemBuffer;
         MyLength = sizeof (FILE_FS_FULL_SIZE_INFORMATION);
		     if (CallerLength<MyLength)  __leave;
		     RtlZeroMemory(PtrFullInfo,CallerLength);
         PtrFullInfo->BytesPerSector = SECTOR_SIZE;
         Pom = PtrVCB->SuperBlock.fs_old_cstotal.cs_nbfree;
				 PtrFullInfo->ActualAvailableAllocationUnits.LowPart	= Pom;
				 PtrFullInfo->CallerAvailableAllocationUnits.LowPart = Pom;
				 PtrFullInfo->SectorsPerAllocationUnit	= PtrVCB->SuperBlock.fs_bsize / SECTOR_SIZE;
				 Pom = PtrVCB->SuperBlock.fs_old_size;
				 PtrFullInfo->TotalAllocationUnits.LowPart = Pom;
				 Result = STATUS_SUCCESS;
			break;


			default:
			Result = STATUS_INVALID_DEVICE_REQUEST;
		}/* switch */
	}
	__finally
	{
		switch (Step)
		{
			case 1:
			 ExReleaseResourceLite(&(PtrVolume->MainResource));
		} /*switch*/
	}/*finally */
	PtrIrp->IoStatus.Information =MyLength;
	PtrIrp->IoStatus.Status = Result;
	IoCompleteRequest(PtrIrp, IO_NO_INCREMENT);
	return (Result);
}/*QueryVolume*/
