#include "inc/ffs.h"
#include "read.tmh"
/******************************************************************************
*Kvoli tomuto to vsetko je
******************************************************************************/
NTSTATUS
Read(
	IN PDEVICE_OBJECT  PtrDeviceObject,
	IN PIRP  PtrIrp)
{
	NTSTATUS				    Result = STATUS_INVALID_PARAMETER;
	PIO_STACK_LOCATION	PtrIrpSp = NULL;
	UINT64        		  ByteOffset;
	UINT32					    ReadLength = 0, TruncatedReadLength = 0;
	UINT32					    NumberBytesRead = 0;
	PFILE_OBJECT			  PtrFO = NULL;
	PTR_T_FCB				    PtrFCB = NULL;
	PTR_T_CCB				    PtrCCB = NULL;
	PTR_T_VCB				    PtrVCB = NULL;
	PTR_T_VOLUME        PtrVolume = NULL;
	LARGE_INTEGER       Ofaj;
	UINT32              ActRead = 0;
	//PtrSFsdNTRequiredFCB	PtrReqdFCB = NULL;
	//PERESOURCE				PtrResourceAcquired = NULL;
	//IO_STATUS_BLOCK		LocalIoStatus;
	void						    *PtrSystemBuffer = NULL;
	//uint32					KeyValue = 0;
	BOOLEAN					CompleteIrp = TRUE;
	BOOLEAN					PostRequest = FALSE;
	BOOLEAN					CanWait = FALSE;
	BOOLEAN					PagingIo = FALSE;
	BOOLEAN					NonBufferedIo = FALSE;
	BOOLEAN					SynchronousIo = FALSE;
  int             Step = 0;
	__try {
		if (PtrDeviceObject == GlobalData.PtrMainDeviceObject) __leave;
		//z hlavneho zriadenia sa neda citat
		PtrIrpSp = IoGetCurrentIrpStackLocation(PtrIrp);
		if (!(PtrIrpSp)) __leave;
		PtrFO = PtrIrpSp->FileObject;
		if  (!(PtrFO)) __leave;
		// Get the FCB and CCB pointers
		Result = CheckBoth(PtrFO->FsContext2);
		if (!NT_SUCCESS(Result)) __leave;
		PtrCCB = (PTR_T_CCB)(PtrFO->FsContext2);
		PtrFCB = PtrCCB->PtrParentFCB;
		// Get some of the parameters supplied to us
		ByteOffset = PtrIrpSp->Parameters.Read.ByteOffset.QuadPart;
		ReadLength = PtrIrpSp->Parameters.Read.Length;
		//CanWait = (FLAG_ON(PtrIrpSp->IrpContextFlags , SFSD_IRP_CONTEXT_CAN_BLOCK) ? TRUE : FALSE);
		PagingIo = (FLAG_ON(PtrIrp->Flags ,IRP_PAGING_IO) ? TRUE : FALSE);
		NonBufferedIo = (FLAG_ON(PtrIrp->Flags , IRP_NOCACHE) ? TRUE : FALSE);
		SynchronousIo = (FLAG_ON(PtrFO->Flags , FO_SYNCHRONOUS_IO) ? TRUE : FALSE);
		if (ReadLength == 0)
		{
			//  0 ako dobre
			Result = STATUS_SUCCESS;
			__leave;
		}
		PtrVCB = PtrFCB->PtrParentVCB;
    PtrVolume = PtrDeviceObject->DeviceExtension;
		if (PtrVolume->Magic!= VOLUME_MAGIC) __leave;

		if (FLAG_ON(PtrFCB->DiskInode.di_mode,IFDIR)) __leave;
		//neviem citat z adresara

		//Citanie samotnej jednotky
		if (&(PtrVolume->VolumeFCB)==PtrFCB) __leave;
		//este  nie je  implementovane
		Step++;/*1*/
		ExAcquireResourceSharedLite(&(PtrVolume->MainResource),TRUE);
		if (!(ByteOffset < PtrFCB->DiskInode.di_size))
		{
					//tu by skor mal byt vypis chyby
					Result = STATUS_SUCCESS;
					__leave;
		}
		Result =  ReadBytes( PtrFCB,
											   ByteOffset,
											   ReadLength,
											   &ActRead,
                         PtrIrp->AssociatedIrp.SystemBuffer);
    if (!NT_SUCCESS(Result)) __leave;
	}
	__finally
	{
		if (Step>0) ExReleaseResourceLite(&(PtrVolume->MainResource));
	}
	//PtrIrp->IoStatus.Information =PtrIrpSp->Parameters.Read.Length;;
	Ofaj.QuadPart = ActRead;
	PtrFO->CurrentByteOffset.QuadPart =ByteOffset+ActRead;
	PtrIrp->IoStatus.Information = Ofaj.LowPart;
	PtrIrp->IoStatus.Status = Result;
	IoCompleteRequest(PtrIrp, IO_NO_INCREMENT);
	return Result;
}



